<!DOCTYPE html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <title>Dashboard for /var/www/html/ci3/application/libraries</title>
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href="../.css/bootstrap.min.css" rel="stylesheet" type="text/css">
  <link href="../.css/nv.d3.min.css" rel="stylesheet" type="text/css">
  <link href="../.css/style.css" rel="stylesheet" type="text/css">
  <!--[if lt IE 9]>
  <script src="../.js/html5shiv.min.js"></script>
  <script src="../.js/respond.min.js"></script>
  <![endif]-->
 </head>
 <body>
  <header>
   <div class="container">
    <div class="row">
     <div class="col-md-12">
      <ol class="breadcrumb">
        <li><a href="../index.html">/var/www/html/ci3/application</a></li>
        <li><a href="index.html">libraries</a></li>
        <li class="active">(Dashboard)</li>

      </ol>
     </div>
    </div>
   </div>
  </header>
  <div class="container">
   <div class="row">
    <div class="col-md-12">
     <h2>Classes</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="classCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="classComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Format.php.html#12">Format</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#18">REST_Controller</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#11">Seeder</a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#3">MY_Session</a></td><td class="text-right">0%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Class</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="REST_Controller.php.html#18">REST_Controller</a></td><td class="text-right">74802</td></tr>
       <tr><td><a href="Format.php.html#12">Format</a></td><td class="text-right">4290</td></tr>
       <tr><td><a href="Seeder.php.html#11">Seeder</a></td><td class="text-right">210</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#3">MY_Session</a></td><td class="text-right">20</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-12">
     <h2>Methods</h2>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Coverage Distribution</h3>
     <div id="methodCoverageDistribution" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Complexity</h3>
     <div id="methodComplexity" style="height: 300px;">
       <svg></svg>
     </div>
    </div>
   </div>
   <div class="row">
    <div class="col-md-6">
     <h3>Insufficient Coverage</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right">Coverage</th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="Format.php.html#83"><abbr title="Format::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1702"><abbr title="REST_Controller::query">query</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1940"><abbr title="REST_Controller::_check_php_session">_check_php_session</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1885"><abbr title="REST_Controller::_check_login">_check_login</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1846"><abbr title="REST_Controller::_perform_library_auth">_perform_library_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1751"><abbr title="REST_Controller::_perform_ldap_auth">_perform_ldap_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1734"><abbr title="REST_Controller::validation_errors">validation_errors</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1721"><abbr title="REST_Controller::_xss_clean">_xss_clean</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1683"><abbr title="REST_Controller::patch">patch</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2003"><abbr title="REST_Controller::_prepare_digest_auth">_prepare_digest_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1664"><abbr title="REST_Controller::delete">delete</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1645"><abbr title="REST_Controller::put">put</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1626"><abbr title="REST_Controller::post">post</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1607"><abbr title="REST_Controller::head">head</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1588"><abbr title="REST_Controller::options">options</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1569"><abbr title="REST_Controller::get">get</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1962"><abbr title="REST_Controller::_prepare_basic_auth">_prepare_basic_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2060"><abbr title="REST_Controller::_check_blacklist_auth">_check_blacklist_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1538"><abbr title="REST_Controller::_parse_delete">_parse_delete</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#53"><abbr title="Seeder::call">call</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#5"><abbr title="MY_Session::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#129"><abbr title="Seeder::__get">__get</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#124"><abbr title="Seeder::setPath">setPath</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#104"><abbr title="Seeder::callDependency">callDependency</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#86"><abbr title="Seeder::callDependencies">callDependencies</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#73"><abbr title="Seeder::loadSeeder">loadSeeder</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Seeder.php.html#38"><abbr title="Seeder::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2082"><abbr title="REST_Controller::_check_whitelist_auth">_check_whitelist_auth</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2265"><abbr title="REST_Controller::logs">logs</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2220"><abbr title="REST_Controller::_check_cors">_check_cors</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2178"><abbr title="REST_Controller::_check_access">_check_access</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2162"><abbr title="REST_Controller::_log_response_code">_log_response_code</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2144"><abbr title="REST_Controller::_log_access_time">_log_access_time</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#2112"><abbr title="REST_Controller::_force_login">_force_login</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1553"><abbr title="REST_Controller::_parse_query">_parse_query</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1518"><abbr title="REST_Controller::_parse_patch">_parse_patch</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#117"><abbr title="Format::factory">factory</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#470"><abbr title="Format::_from_xml">_from_xml</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#380"><abbr title="REST_Controller::__construct">__construct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#369"><abbr title="REST_Controller::early_checks">early_checks</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#523"><abbr title="Format::_from_php">_from_php</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#514"><abbr title="Format::_from_serialize">_from_serialize</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#505"><abbr title="Format::_from_json">_from_json</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#484"><abbr title="Format::_from_csv">_from_csv</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#452"><abbr title="Format::to_php">to_php</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#601"><abbr title="REST_Controller::preflight_checks">preflight_checks</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#433"><abbr title="Format::to_serialized">to_serialized</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#395"><abbr title="Format::to_json">to_json</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#306"><abbr title="Format::to_csv">to_csv</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#251"><abbr title="Format::to_html">to_html</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#174"><abbr title="Format::to_xml">to_xml</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Format.php.html#134"><abbr title="Format::to_array">to_array</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#583"><abbr title="REST_Controller::__destruct">__destruct</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#626"><abbr title="REST_Controller::_remap">_remap</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1503"><abbr title="REST_Controller::_parse_options">_parse_options</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1112"><abbr title="REST_Controller::_log_request">_log_request</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1488"><abbr title="REST_Controller::_parse_head">_parse_head</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1465"><abbr title="REST_Controller::_parse_put">_parse_put</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1449"><abbr title="REST_Controller::_parse_post">_parse_post</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1437"><abbr title="REST_Controller::_parse_get">_parse_get</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1245"><abbr title="REST_Controller::_auth_override_check">_auth_override_check</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1140"><abbr title="REST_Controller::_check_limit">_check_limit</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1077"><abbr title="REST_Controller::_detect_lang">_detect_lang</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#761"><abbr title="REST_Controller::response">response</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#1003"><abbr title="REST_Controller::_detect_api_key">_detect_api_key</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#971"><abbr title="REST_Controller::_detect_method">_detect_method</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#900"><abbr title="REST_Controller::_detect_output_format">_detect_output_format</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#888"><abbr title="REST_Controller::_get_default_output_format">_get_default_output_format</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#852"><abbr title="REST_Controller::_detect_input_format">_detect_input_format</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="REST_Controller.php.html#841"><abbr title="REST_Controller::set_response">set_response</abbr></a></td><td class="text-right">0%</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#16"><abbr title="MY_Session::sess_destroy">sess_destroy</abbr></a></td><td class="text-right">0%</td></tr>

       </tbody>
      </table>
     </div>
    </div>
    <div class="col-md-6">
     <h3>Project Risks</h3>
     <div class="scrollbox">
      <table class="table">
       <thead>
        <tr>
         <th>Method</th>
         <th class="text-right"><abbr title="Change Risk Anti-Patterns (CRAP) Index">CRAP</abbr></th>
        </tr>
       </thead>
       <tbody>
       <tr><td><a href="REST_Controller.php.html#626"><abbr title="REST_Controller::_remap">_remap</abbr></a></td><td class="text-right">1190</td></tr>
       <tr><td><a href="REST_Controller.php.html#380"><abbr title="REST_Controller::__construct">__construct</abbr></a></td><td class="text-right">812</td></tr>
       <tr><td><a href="REST_Controller.php.html#1245"><abbr title="REST_Controller::_auth_override_check">_auth_override_check</abbr></a></td><td class="text-right">756</td></tr>
       <tr><td><a href="Format.php.html#174"><abbr title="Format::to_xml">to_xml</abbr></a></td><td class="text-right">306</td></tr>
       <tr><td><a href="REST_Controller.php.html#900"><abbr title="REST_Controller::_detect_output_format">_detect_output_format</abbr></a></td><td class="text-right">240</td></tr>
       <tr><td><a href="REST_Controller.php.html#1140"><abbr title="REST_Controller::_check_limit">_check_limit</abbr></a></td><td class="text-right">182</td></tr>
       <tr><td><a href="Format.php.html#306"><abbr title="Format::to_csv">to_csv</abbr></a></td><td class="text-right">132</td></tr>
       <tr><td><a href="REST_Controller.php.html#1003"><abbr title="REST_Controller::_detect_api_key">_detect_api_key</abbr></a></td><td class="text-right">132</td></tr>
       <tr><td><a href="REST_Controller.php.html#761"><abbr title="REST_Controller::response">response</abbr></a></td><td class="text-right">132</td></tr>
       <tr><td><a href="REST_Controller.php.html#1751"><abbr title="REST_Controller::_perform_ldap_auth">_perform_ldap_auth</abbr></a></td><td class="text-right">110</td></tr>
       <tr><td><a href="REST_Controller.php.html#1885"><abbr title="REST_Controller::_check_login">_check_login</abbr></a></td><td class="text-right">110</td></tr>
       <tr><td><a href="REST_Controller.php.html#2003"><abbr title="REST_Controller::_prepare_digest_auth">_prepare_digest_auth</abbr></a></td><td class="text-right">90</td></tr>
       <tr><td><a href="Format.php.html#251"><abbr title="Format::to_html">to_html</abbr></a></td><td class="text-right">56</td></tr>
       <tr><td><a href="Format.php.html#134"><abbr title="Format::to_array">to_array</abbr></a></td><td class="text-right">56</td></tr>
       <tr><td><a href="REST_Controller.php.html#1962"><abbr title="REST_Controller::_prepare_basic_auth">_prepare_basic_auth</abbr></a></td><td class="text-right">42</td></tr>
       <tr><td><a href="REST_Controller.php.html#971"><abbr title="REST_Controller::_detect_method">_detect_method</abbr></a></td><td class="text-right">42</td></tr>
       <tr><td><a href="REST_Controller.php.html#852"><abbr title="REST_Controller::_detect_input_format">_detect_input_format</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="REST_Controller.php.html#1846"><abbr title="REST_Controller::_perform_library_auth">_perform_library_auth</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="REST_Controller.php.html#2220"><abbr title="REST_Controller::_check_cors">_check_cors</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="Format.php.html#395"><abbr title="Format::to_json">to_json</abbr></a></td><td class="text-right">30</td></tr>
       <tr><td><a href="REST_Controller.php.html#1077"><abbr title="REST_Controller::_detect_lang">_detect_lang</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="REST_Controller.php.html#1112"><abbr title="REST_Controller::_log_request">_log_request</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="REST_Controller.php.html#2178"><abbr title="REST_Controller::_check_access">_check_access</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="Seeder.php.html#53"><abbr title="Seeder::call">call</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="REST_Controller.php.html#1465"><abbr title="REST_Controller::_parse_put">_parse_put</abbr></a></td><td class="text-right">20</td></tr>
       <tr><td><a href="REST_Controller.php.html#1645"><abbr title="REST_Controller::put">put</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#2082"><abbr title="REST_Controller::_check_whitelist_auth">_check_whitelist_auth</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1721"><abbr title="REST_Controller::_xss_clean">_xss_clean</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1702"><abbr title="REST_Controller::query">query</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1683"><abbr title="REST_Controller::patch">patch</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1664"><abbr title="REST_Controller::delete">delete</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Format.php.html#83"><abbr title="Format::__construct">__construct</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1626"><abbr title="REST_Controller::post">post</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1607"><abbr title="REST_Controller::head">head</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1588"><abbr title="REST_Controller::options">options</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1569"><abbr title="REST_Controller::get">get</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#1518"><abbr title="REST_Controller::_parse_patch">_parse_patch</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Seeder.php.html#86"><abbr title="Seeder::callDependencies">callDependencies</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#601"><abbr title="REST_Controller::preflight_checks">preflight_checks</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Seeder.php.html#104"><abbr title="Seeder::callDependency">callDependency</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Format.php.html#484"><abbr title="Format::_from_csv">_from_csv</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Format.php.html#452"><abbr title="Format::to_php">to_php</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="Format.php.html#433"><abbr title="Format::to_serialized">to_serialized</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#2112"><abbr title="REST_Controller::_force_login">_force_login</abbr></a></td><td class="text-right">12</td></tr>
       <tr><td><a href="REST_Controller.php.html#2265"><abbr title="REST_Controller::logs">logs</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#5"><abbr title="MY_Session::__construct">__construct</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#1538"><abbr title="REST_Controller::_parse_delete">_parse_delete</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#2060"><abbr title="REST_Controller::_check_blacklist_auth">_check_blacklist_auth</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#1940"><abbr title="REST_Controller::_check_php_session">_check_php_session</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#1449"><abbr title="REST_Controller::_parse_post">_parse_post</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#888"><abbr title="REST_Controller::_get_default_output_format">_get_default_output_format</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="REST_Controller.php.html#583"><abbr title="REST_Controller::__destruct">__destruct</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Format.php.html#470"><abbr title="Format::_from_xml">_from_xml</abbr></a></td><td class="text-right">6</td></tr>
       <tr><td><a href="Session/MY_Session.php.html#16"><abbr title="MY_Session::sess_destroy">sess_destroy</abbr></a></td><td class="text-right">6</td></tr>

       </tbody>
      </table>
     </div>
    </div>
   </div>
   <footer>
    <hr/>
    <p>
     <small>Generated by <a href="https://github.com/sebastianbergmann/php-code-coverage" target="_top">php-code-coverage 5.3.0</a> using <a href="https://secure.php.net/" target="_top">PHP 7.2.34-8+ubuntu18.04.1+deb.sury.org+1</a> with <a href="https://xdebug.org/">Xdebug 3.0.1</a> and <a href="https://phpunit.de/">PHPUnit 6.5.5</a> at Fri Jan 15 12:48:23 UTC 2021.</small>
    </p>
   </footer>
  </div>
  <script src="../.js/jquery.min.js" type="text/javascript"></script>
  <script src="../.js/bootstrap.min.js" type="text/javascript"></script>
  <script src="../.js/holder.min.js" type="text/javascript"></script>
  <script src="../.js/d3.min.js" type="text/javascript"></script>
  <script src="../.js/nv.d3.min.js" type="text/javascript"></script>
  <script type="text/javascript">
$(document).ready(function() {
  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#classCoverageDistribution svg')
      .datum(getCoverageDistributionData([4,0,0,0,0,0,0,0,0,0,0,0], "Class Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.multiBarChart();
    chart.tooltips(false)
      .showControls(false)
      .showLegend(false)
      .reduceXTicks(false)
      .staggerLabels(true)
      .yAxis.tickFormat(d3.format('d'));

    d3.select('#methodCoverageDistribution svg')
      .datum(getCoverageDistributionData([71,0,0,0,0,0,0,0,0,0,0,0], "Method Coverage"))
      .transition().duration(500).call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getCoverageDistributionData(data, label) {
    var labels = [
      '0%',
      '0-10%',
      '10-20%',
      '20-30%',
      '30-40%',
      '40-50%',
      '50-60%',
      '60-70%',
      '70-80%',
      '80-90%',
      '90-100%',
      '100%'
    ];
    var values = [];
    $.each(labels, function(key) {
      values.push({x: labels[key], y: data[key]});
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Cyclomatic Complexity');

    d3.select('#classComplexity svg')
      .datum(getComplexityData([[0,65,"<a href=\"Format.php.html#12\">Format<\/a>"],[0,273,"<a href=\"REST_Controller.php.html#18\">REST_Controller<\/a>"],[0,14,"<a href=\"Seeder.php.html#11\">Seeder<\/a>"],[0,4,"<a href=\"Session\/MY_Session.php.html#3\">MY_Session<\/a>"]], 'Class Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  nv.addGraph(function() {
    var chart = nv.models.scatterChart()
      .showDistX(true)
      .showDistY(true)
      .showLegend(false)
      .forceX([0, 100]);
    chart.tooltipContent(function(graph) {
      return '<p>' + graph.point.class + '</p>';
    });

    chart.xAxis.axisLabel('Code Coverage (in percent)');
    chart.yAxis.axisLabel('Method Complexity');

    d3.select('#methodComplexity svg')
      .datum(getComplexityData([[0,3,"<a href=\"Format.php.html#83\">Format::__construct<\/a>"],[0,1,"<a href=\"Format.php.html#117\">Format::factory<\/a>"],[0,7,"<a href=\"Format.php.html#134\">Format::to_array<\/a>"],[0,17,"<a href=\"Format.php.html#174\">Format::to_xml<\/a>"],[0,7,"<a href=\"Format.php.html#251\">Format::to_html<\/a>"],[0,11,"<a href=\"Format.php.html#306\">Format::to_csv<\/a>"],[0,5,"<a href=\"Format.php.html#395\">Format::to_json<\/a>"],[0,3,"<a href=\"Format.php.html#433\">Format::to_serialized<\/a>"],[0,3,"<a href=\"Format.php.html#452\">Format::to_php<\/a>"],[0,2,"<a href=\"Format.php.html#470\">Format::_from_xml<\/a>"],[0,3,"<a href=\"Format.php.html#484\">Format::_from_csv<\/a>"],[0,1,"<a href=\"Format.php.html#505\">Format::_from_json<\/a>"],[0,1,"<a href=\"Format.php.html#514\">Format::_from_serialize<\/a>"],[0,1,"<a href=\"Format.php.html#523\">Format::_from_php<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#369\">REST_Controller::early_checks<\/a>"],[0,28,"<a href=\"REST_Controller.php.html#380\">REST_Controller::__construct<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#583\">REST_Controller::__destruct<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#601\">REST_Controller::preflight_checks<\/a>"],[0,34,"<a href=\"REST_Controller.php.html#626\">REST_Controller::_remap<\/a>"],[0,11,"<a href=\"REST_Controller.php.html#761\">REST_Controller::response<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#841\">REST_Controller::set_response<\/a>"],[0,5,"<a href=\"REST_Controller.php.html#852\">REST_Controller::_detect_input_format<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#888\">REST_Controller::_get_default_output_format<\/a>"],[0,15,"<a href=\"REST_Controller.php.html#900\">REST_Controller::_detect_output_format<\/a>"],[0,6,"<a href=\"REST_Controller.php.html#971\">REST_Controller::_detect_method<\/a>"],[0,11,"<a href=\"REST_Controller.php.html#1003\">REST_Controller::_detect_api_key<\/a>"],[0,4,"<a href=\"REST_Controller.php.html#1077\">REST_Controller::_detect_lang<\/a>"],[0,4,"<a href=\"REST_Controller.php.html#1112\">REST_Controller::_log_request<\/a>"],[0,13,"<a href=\"REST_Controller.php.html#1140\">REST_Controller::_check_limit<\/a>"],[0,27,"<a href=\"REST_Controller.php.html#1245\">REST_Controller::_auth_override_check<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#1437\">REST_Controller::_parse_get<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#1449\">REST_Controller::_parse_post<\/a>"],[0,4,"<a href=\"REST_Controller.php.html#1465\">REST_Controller::_parse_put<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#1488\">REST_Controller::_parse_head<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#1503\">REST_Controller::_parse_options<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1518\">REST_Controller::_parse_patch<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#1538\">REST_Controller::_parse_delete<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#1553\">REST_Controller::_parse_query<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1569\">REST_Controller::get<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1588\">REST_Controller::options<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1607\">REST_Controller::head<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1626\">REST_Controller::post<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1645\">REST_Controller::put<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1664\">REST_Controller::delete<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1683\">REST_Controller::patch<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1702\">REST_Controller::query<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#1721\">REST_Controller::_xss_clean<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#1734\">REST_Controller::validation_errors<\/a>"],[0,10,"<a href=\"REST_Controller.php.html#1751\">REST_Controller::_perform_ldap_auth<\/a>"],[0,5,"<a href=\"REST_Controller.php.html#1846\">REST_Controller::_perform_library_auth<\/a>"],[0,10,"<a href=\"REST_Controller.php.html#1885\">REST_Controller::_check_login<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#1940\">REST_Controller::_check_php_session<\/a>"],[0,6,"<a href=\"REST_Controller.php.html#1962\">REST_Controller::_prepare_basic_auth<\/a>"],[0,9,"<a href=\"REST_Controller.php.html#2003\">REST_Controller::_prepare_digest_auth<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#2060\">REST_Controller::_check_blacklist_auth<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#2082\">REST_Controller::_check_whitelist_auth<\/a>"],[0,3,"<a href=\"REST_Controller.php.html#2112\">REST_Controller::_force_login<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#2144\">REST_Controller::_log_access_time<\/a>"],[0,1,"<a href=\"REST_Controller.php.html#2162\">REST_Controller::_log_response_code<\/a>"],[0,4,"<a href=\"REST_Controller.php.html#2178\">REST_Controller::_check_access<\/a>"],[0,5,"<a href=\"REST_Controller.php.html#2220\">REST_Controller::_check_cors<\/a>"],[0,2,"<a href=\"REST_Controller.php.html#2265\">REST_Controller::logs<\/a>"],[0,1,"<a href=\"Seeder.php.html#38\">Seeder::__construct<\/a>"],[0,4,"<a href=\"Seeder.php.html#53\">Seeder::call<\/a>"],[0,1,"<a href=\"Seeder.php.html#73\">Seeder::loadSeeder<\/a>"],[0,3,"<a href=\"Seeder.php.html#86\">Seeder::callDependencies<\/a>"],[0,3,"<a href=\"Seeder.php.html#104\">Seeder::callDependency<\/a>"],[0,1,"<a href=\"Seeder.php.html#124\">Seeder::setPath<\/a>"],[0,1,"<a href=\"Seeder.php.html#129\">Seeder::__get<\/a>"],[0,2,"<a href=\"Session\/MY_Session.php.html#5\">MY_Session::__construct<\/a>"],[0,2,"<a href=\"Session\/MY_Session.php.html#16\">MY_Session::sess_destroy<\/a>"]], 'Method Complexity'))
      .transition()
      .duration(500)
      .call(chart);

    nv.utils.windowResize(chart.update);

    return chart;
  });

  function getComplexityData(data, label) {
    var values = [];
    $.each(data, function(key) {
      var value = Math.round(data[key][0]*100) / 100;
      values.push({
        x: value,
        y: data[key][1],
        class: data[key][2],
        size: 0.05,
        shape: 'diamond'
      });
    });

    return [
      {
        key: label,
        values: values,
        color: "#4572A7"
      }
    ];
  }
});
  </script>
 </body>
</html>
